using Dynamicweb;
using Dynamicweb.Ecommerce.LiveIntegration.Configuration;
using Dynamicweb.Extensibility.Notifications;
using System;

namespace Dynamicweb.Ecommerce.LiveIntegration.NotificationSubscribers
{
    [Subscribe(Dynamicweb.Notifications.Standard.Page.OnGlobalTags)]
    public class PageOnGlobalTagsObserver : NotificationSubscriber
    {
        public override void OnNotify(string notification, Dynamicweb.Extensibility.Notifications.NotificationArgs args)
        {
            Dynamicweb.Notifications.Standard.Page.PageviewNotificationArgs pageviewNotificationArgs = args as Dynamicweb.Notifications.Standard.Page.PageviewNotificationArgs;

            string globalTagName = Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.WebSeviceConnectionStatusGlobalTagName);
            
            if (!string.IsNullOrEmpty(globalTagName))
            {
                if (pageviewNotificationArgs.Template.TemplateBaseType == Rendering.Template.TemplateType.Razor ||
                    pageviewNotificationArgs.Pageview?.Template?.TemplateBaseType == Rendering.Template.TemplateType.Razor || 
                    pageviewNotificationArgs.Template.TagExists(globalTagName))    
                {
                    if ((string.IsNullOrEmpty(Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.Shop)) ||
                            Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path,
                                Constants.WebServiceConfiguration.Shop) == (String)Dynamicweb.Frontend.PageView.Current().Area.EcomShopId)
                                    && UrlHandler.Instance.IsWebServiceUrlFound())
                    {
                        pageviewNotificationArgs.Template.SetTag(globalTagName, Connector.IsWebServiceConnectionAvailable().ToString().ToLower());
                    }
                }
            }
        }
    }
}